//-------------------------------------------------------------------------
// Filename:      channel2channel.hh
// Version:       $Id: channel2channel.hh,v 1.1.2.2 1999/06/09 10:14:03 erik Exp $
// Copyright:     Copyright (C) 1999, Erik Mouw (J.A.K.Mouw@its.tudelft.nl)
// Author:        Erik Mouw <J.A.K.Mouw@its.tudelft.nl>
// Description:   Remap channels.
// Created at:    Mon May 24 16:12:55 1999
// Modified by:   Erik Mouw <J.A.K.Mouw@its.tudelft.nl>
// Modified at:   Wed Jun  9 12:02:38 1999
//-------------------------------------------------------------------------
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#ident "$Id: channel2channel.hh,v 1.1.2.2 1999/06/09 10:14:03 erik Exp $"

#ifndef musica_channel2channel_hh
#define musica_channel2channel_hh




#include "mididevice.hh"




class midiChannel2Channel : virtual public midiDevice
{
protected:
  midiDevice *device;
  
  int channelMap[numMidiChannels];

public:
  midiChannel2Channel(const char *theName);
  virtual ~midiChannel2Channel(void);

  void setDevice(midiDevice *d);
  midiDevice *getDevice(void);

  void setChannel(int from, int to);
  void setDefaultChannels(void);
  int getChannel(int from);

  // fill in virtual functions
  virtual bool open(void);
  virtual bool close(void);

  virtual void noteOn(int channel, int key, int velocity);
  virtual void noteOff(int channel, int key, int velocity);
  
  virtual void keyPressure(int channel, int key, int pressure);
  virtual void channelPressure(int channel, int pressure);
  
  virtual void pitchBend(int channel, int fine, int coarse);

  virtual void controlChange(int channel, int controller, int value);

  virtual void programChange(int channel, int program);

  virtual void allNoteOff(void);

  virtual void systemReset(void);
};




#endif
