//-------------------------------------------------------------------------
// Filename:      track.hh
// Version:       $Id: track.hh,v 1.1.2.2 1999/06/09 10:14:04 erik Exp $
// Copyright:     Copyright (C) 1999, Erik Mouw (J.A.K.Mouw@its.tudelft.nl)
// Author:        Erik Mouw <J.A.K.Mouw@its.tudelft.nl>
// Description:   MIDI track class
// Created at:    Sat May 15 14:24:01 1999
// Modified by:   Erik Mouw <J.A.K.Mouw@its.tudelft.nl>
// Modified at:   Wed May 26 17:11:56 1999
//-------------------------------------------------------------------------
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#ident "$Id: track.hh,v 1.1.2.2 1999/06/09 10:14:04 erik Exp $"

#ifndef musica_track_hh
#define musica_track_hh




#include "events.hh"
#include "mididevice.hh"




class midiTrack
{
private:
  midiEvent *events;
  midiEvent *lastEvent;
  midiEvent *currentEvent;
  long int currentTime;
  long int nextTime;

public:
  // constructor
  midiTrack(void);

  // destructor
  ~midiTrack(void);

  void addEvent(midiEvent *event);

  midiEvent *getCurrentEvent(void) { return(currentEvent); };
  midiEvent *getNextEvent(void);
  midiEvent *rewind(void);

  long int getCurrentTime(void) { return(currentTime); };
  long int getNextTime(void)    { return(nextTime); };

  void play(midiDevice *device, midiPlayer *player);
};




#endif
